<?php
/*
Plugin Name: yaCAPTCHA
Plugin URI: http://www.remyroy.com/yacaptcha
Description: Yet Another CAPTCHA plugin for WordPress based on <a href="http://www.captcha.ru/en/">KCAPTCHA</a>.
Version: 1.3
Author: Rémy Roy
Author URI: http://www.remyroy.com
*/
/*  Copyright 2008  Rémy Roy  (email : remyroy@remyroy.com)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

$yaCaptchaCharInputMsg = 'Characters in the image above (required)';
$yaCaptchaCharNoMatchMsg = 'Characters do not match what is shown in the image. Please retry.';

function yaCaptchaInit() {
    add_action('comment_form', 'yaCaptchaCommentForm');
    add_action('comment_post', 'yaCaptchaCommentPost');
}

function yaCaptchaCommentForm($id) {

    global $userdata;
    global $yaCaptchaCharInputMsg;
    get_currentuserinfo();

    if ('' == $userdata->ID) {
        ?>
        <p>
        
        <img src="<?php bloginfo('url'); ?>/wp-content/plugins/yacaptcha/captcha-image.php" width="120" height="60" alt="CAPTCHA image" />
           
        <br />
        
        <input id="captcha" name="captcha" type="text" value="" />
        
        <label for="captcha"><small><?php echo __($yaCaptchaCharInputMsg); ?></small></label>
        
        </p>
        <?php
    }
}

function yaCaptchaCommentPost($id) {

    global $userdata;
    global $yaCaptchaCharNoMatchMsg;
    get_currentuserinfo();
    
    session_start();

    if ('' == $userdata->ID && !(isset($_SESSION['captcha_keystring']) && $_SESSION['captcha_keystring'] ==  $_POST['captcha'])) {
    
        wp_set_comment_status($id, 'delete');
        
        if (function_exists('wp_die')) {
            wp_die( __($yaCaptchaCharNoMatchMsg) );
        }
        else {
            die( __($yaCaptchaCharNoMatchMsg) );
        }
    
    }
}

yaCaptchaInit();

?>